#pragma once

#include "GdiPlusWrapper.h"
#include "WorkGroupDlg.h"
#include "SkinDialog.h"
#include "ScrollStatic.h"
#include "FavoriteController.h"
#include "ChatListCtrl.h"
#include "NMImgTabButton.h"
#include "RecentContacts.h"
//-----------------------------------------------------------------------------
// by cscho
// New UI
#define ID_INFOITEM_NOTE			(0xB001)
#define ID_INFOITEM_MAIL			(0xB002)
#define ID_INFOITEM_VOC				(0xB003)
#define ID_INFOITEM_SIGN			(0xB004)
#define ID_INFOITEM_SURVEY			(0xB005)
#define ID_INFOITEM_WORKORG			(0xB006)
#define ID_INFOITEM_IN				(0xB007)
#define ID_INFOITEM_SAM				(0xB008)
#define ID_INFOITEM_CHAT			(0xB009)
#include "InfoItemWnd.h"

#define ID_INFO_VOLUME				(0xA001)
#include "InfoVolumeWnd.h"

#define ID_INFO_ABOUTME				(0xD001)
#include "InfoAboutMeWnd.h"
#define ID_IPT_ABOUTME				(0xDEE3)

#define ID_INFO_SEARCH				(0xE001)
#include "InfoSearchWnd.h"

#define DEF_OUTLINK_HEIGHT			(27)
#define DEF_SEARCH_BAR_GAP_Y		(5)
#define DEF_SEARCH_BAR_GAP_X_L		(10)
#define DEF_SEARCH_BAR_GAP_X_R		(32)
#define DEF_BANNER_HEIGHT			(60)
#define DEF_LEGACY_BTN_WIDTH		(46)
#define DEF_LEGACY_BTN_HEIGHT		(32)

#define ID_INFO_BANNER				(0xF001)
#include "InfoBannerWnd.h"

#define ID_INFO_OUTLINK				(0xC001)
#include "InfoOutlinkWnd.h"
#include "afxext.h"
#include "RecentContacts.h"
//-----------------------------------------------------------------------------

class CNeMessengerDlg;
class CLayeredDlg;

class CMainDlg : public CDialog
{
	DECLARE_DYNAMIC(CMainDlg)

public:
	CMainDlg(CWnd* pParent = NULL);   // ǥ Դϴ.
	virtual ~CMainDlg();

// ȭ  Դϴ.
	enum { IDD = IDD_MAIN_DIALOG };	

protected:	
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.

public:
	//make this as static, so NTRAY.cpp can use same status popup munu
	//TODO: move this code to common file?
	static BOOL                 MakeAboutMeSatusPopupMenu(CMenu* pMenu);
	static BOOL                 MakeAboutIPTSatusPopupMenu(CMenu* pMenu);
	
	void						SetParent(CNeMessengerDlg* pDlg);

	void						AddFavorite(const NE_MEMBER_DATA member);
	void						InitMyProfile(void);
	
	CString						RegNtalkWndClass(CString strClassNamePrefix);
	void						InitLegacySysCtrl();
	void						InitUserVolumnCtrl();
	void						InitInfoAboutMe();
	void						InitInfoSearch();
	void						InitOutlinkCtrl();
	void						InitBannerCtrl();
	void						InitLegacyBtnPos();

	void						SetInfoItemCount(NTHanatourCountType eType, int nCount, CString strURL);

	void						DoInfoItemChat();
	void						DoInfoItemNote();
	void						DoInfoItemMail();
	void						DoInfoItemVOC();

	void						DoInfoItemSign();
	void						DoInfoItemSurvey();
	void						DoInfoItemIN();
	void						DoInfoItemSAM();
	void						DoInfoSearch(CString strSearchText);
	void						ClearFavoriteList();

	void						LoadAboutMeStatusPopup(CPoint pt);
	void						LoadAboutIPTStatusPopup(CPoint pt);
	
	void						UpdateInfoAboutMeStatus(GTUserStatusType gtStatus);
	void						UpdateInfoAboutIPTStatus();
	void						UpdateInfoAboutMeNickName(CString strNickName);
	void						UpdateInfoVolume(UINT nTotalUsedCapa, UINT nLimitedCapa);
	

	GTUserStatusType			GetUserStatusFromUserID(CString strUserID);

	void						ReSizeCtrl(void);	

	LONG						ResizeLegacyButtons( CRect &rcClient, CRect &rtAboutMe );

	void						StartNoticeList(const std::vector<NE_NOTICE_DATA> &vecNoticeList);
	void						RedrawOutlink();

	void						KillAllTimer();
	void						SetAllTimer();
	void						OpenURLService(CString strURL);
	CString						GetLanguage();

	void						ReleaseChatRoomList();
	void						ClearChatRoomList();
	void						RemoveChatRoom( CDialog* pDialog );
	void						AddChatRoomList(BOOL bGroup, int nRoomNo, LPCTSTR usersName, CTime time);
	void						UpdateChatRoomList(int nRoomNo, BOOL bGroup, CString strUserName, CTime time);
	void						SetInfoBtnCount(int nCount)		{ m_nInfoBtnCount = nCount; }
	void						__ResourceLoad(BOOL bInit = FALSE);

	void						SetInfoItemNoteItemCount(int nCount) { m_wndInfoItemNote.SetItemCount(nCount); }
	int							GetInfoItemNoteItemCount() { return m_wndInfoItemNote.GetItemCount(); }

	void						SetInfoItemMailItemCount(int nCount) { m_wndInfoItemMail.SetItemCount(nCount); }

	void						SetBannerList(const std::vector<NE_BANNER_DATA> &vecBannerList) { m_wndBanner.SetBannerList(vecBannerList); }

	BOOL						IsMobileOnline() { return m_wndInfoAboutMe.IsMobileOnline(); }
	void						SetEditNickName(BOOL bEdit) { m_wndInfoAboutMe.SetEditNickName(bEdit); }
	GTUserStatusType			GetMyStatus() { return m_wndInfoAboutMe.GetMyStatus(); }

	HWND						GetFavoriteTreeCtrlHwnd() { return m_favoriteController.GetTreeCtrl().GetSafeHwnd(); }
	void						UpdateAllBuddyDisplayNames() { m_favoriteController.UpdateAllBuddyDisplayNames(); }
	int							GetSelectedOnlineFavoritesCount() { return m_favoriteController.GetSelectedOnlineFavoritesCount(); }
	int							GetSelectedFavoritesCount() { return m_favoriteController.GetSelectedFavoritesCount(); }
	BOOL						IsBuddySelected() const { return m_favoriteController.IsBuddySelected(); }
	BOOL						IsGroupSelected() const { return m_favoriteController.IsGroupSelected(); }
	std::vector<std::wstring>	GetTargetGroupNameList(int nGroupID) { return m_favoriteController.GetTargetGroupNameList(nGroupID); }
	int							GetSelectedOnlineFavorites(std::vector<const IGTBuddyUser*>& buddyUserVector) { return m_favoriteController.GetSelectedOnlineFavorites(buddyUserVector); }
	int							GetSelectedBuddyItems(std::vector<const IGTBuddyUser*>& buddyUserVector) { return m_favoriteController.GetSelectedBuddyItems(buddyUserVector); }
	void						RequestDeleteBuddy() { m_favoriteController.RequestDeleteBuddy(); }
	BOOL						RequestAddGroup() { return m_favoriteController.RequestAddGroup(); }
	void						RequestDeleteGroup(const IGTBuddyGroup* pGroup = NULL) { m_favoriteController.RequestDeleteGroup(pGroup); }
	void						EditLableOn(const IGTBuddyGroup * pGroup = NULL) { m_favoriteController.EditLableOn(pGroup); }
	void						MenuCopyBuddy(UINT nCmdID , int nMenuStartID) { m_favoriteController.MenuCopyBuddy(nCmdID, nMenuStartID); }
	void						MenuMoveBuddy(UINT nCmdID , int nMenuStartID) { m_favoriteController.MenuMoveBuddy(nCmdID, nMenuStartID); }
	void						AddBuddy(const IGTBuddyUser *pUser) { m_favoriteController.AddBuddy(pUser); }
	void						DeleteBuddy(LPCWSTR strUserId, int nGroupId) { m_favoriteController.DeleteBuddy(strUserId, nGroupId); }
	void						MoveBuddy(int nFromGroupID, const IGTBuddyUser* pUser) { m_favoriteController.MoveBuddy(nFromGroupID, pUser); }
	void						UpdateStatus(IGTMessengerActor *pActor, LPCWSTR strBuddyID) { m_favoriteController.UpdateStatus(pActor, strBuddyID); }
	void						AddGroup(const IGTBuddyGroup* pGroup, bool bEditLabel = false) { m_favoriteController.AddGroup(pGroup, bEditLabel); }
	void						UpdateGroupName(const IGTBuddyGroup* pGroup) { m_favoriteController.UpdateGroupName(pGroup); }
	void						RedrawGroup() { m_favoriteController.RedrawGroup(); }

	void						DeleteGroup(int nGroupID) { m_favoriteController.DeleteGroup(nGroupID); }
	int							GetTridID() const{ return m_favoriteController.GetTrid().GetID(); }
	void						InitFavoriteList() { m_favoriteController.InitFavoriteList(); }

	void						FavoriteGroupResort(){m_favoriteController.GroupResort();}
	void						ImportGroup();

	CString						GetMyUserID_Base64();
	CString						GetUserID_Base64(CString strUserID);
	CRecentContacts*			GetRecentContacts(){return &m_recentContacts;}
private:
	CRecentContacts	m_recentContacts;
	CImageList		m_chatRoomImageList;
	CChatListCtrl	m_listChatRoom;
	BOOL			m_bSearch;
	CString			m_strOpenChatSearchext;
	CCriticalSection m_csChatDialogList;
	BOOL			m_bCloseDialog;
	CNMImgButton	m_btnTile;
	CLayeredDlg*	m_pChatAlignHelpLayerDlg;
	CNMImgButton	m_btnLegacyPre;
	CNMImgButton	m_btnLegacyPost;

	CNMImgTabButton m_btnTabFavorite;
	CNMImgTabButton m_btnTabChatList;
	CBitmap			m_bmTopBg;
	CBitmap			m_bmLegacyBg;
	CBitmap			m_bmSearchBg;
	int				m_nInfoBtnCount;	//  ư (ѿ  )

	GROUP_MEMU_LIST			m_GroupList;			//޴  ׷ Ʈ <޴ID, ׷ID>

	CInfoItemWnd				m_wndInfoItemChat;
	CInfoItemWnd				m_wndInfoItemNote;
	CInfoItemWnd				m_wndInfoItemMail;
	CInfoItemWnd				m_wndInfoItemVOC;
	CInfoItemWnd				m_wndInfoItemSign;
	CInfoItemWnd				m_wndInfoItemSurvey;
	CInfoItemWnd				m_wndInfoItemWorkOrg;
	CInfoItemWnd				m_wndInfoItemIN;
	CInfoItemWnd				m_wndInfoItemSAM;
	CInfoBannerWnd				m_wndBanner;

	CInfoVolumeWnd				m_wndInfoVolume;
	CInfoAboutMeWnd				m_wndInfoAboutMe;
	CInfoSearchWnd				m_wndSearch;
	CInfoOutlinkWnd				m_wndOutlink;

	FavoriteController			m_favoriteController;
	CScrollStatic				m_staticNotice;

	std::vector<NE_NOTICE_DATA> m_vecNoticeList;

	

	CNeMessengerDlg*			m_pMessengerMain;
	std::vector<NE_OUTLINK_DATA> m_vecOutLinkList;	
	LONG						m_nLegacyBtnGap;
	LONG						m_nLegacyBtnSX;
	LONG						m_nLegacyBtnMoveSizeRight;
	LONG						m_nLegacyBtnMoveSizeLeft;
	LONG						m_nOldLegacyBgWidth;
	bool						m_bRightLegacyItemShown;

	void			InitList(CChatListCtrl &list, CStringArray &strHeaderTitle);
	void			InitLists();
	void			InitTabButtons();
	void			ResizeListColumn(CChatListCtrl &list, const int *arrWidth);
	void			AdjustAlignButtons( const CRect &rtSearch );
	void			InvalidateChatListSearch();

	BOOL						m_bEnableNotice;
	BOOL						m_bEnableBanner;

protected:
	virtual BOOL OnInitDialog();

	void ShowAlignHelpMsg();

	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);	
	
protected:
	DECLARE_MESSAGE_MAP()
	DECLARE_EVENTSINK_MAP()

	afx_msg LRESULT OnInfoAboutMeEditNickName(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnNotify(WPARAM wParam, LPARAM lParam);

	afx_msg void OnNMRClickMainChatManager(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTvnGetInfoTipFavoriteTree(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTvnEndlabeleditFavoriteTree(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnDestroy();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg LRESULT OnAddUser(WPARAM wParam, LPARAM lParam);
	afx_msg void OnTvnBegindragFavoriteTree(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnLvnItemchangedMainChatManager(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMClickMainChatManager(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedTileButton();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnBnClickedButtonMainLegacyPre();
	afx_msg void OnBnClickedButtonMainLegacyPost();

	void AlignMeultiChatDialog( int nSelectedCount );
	void OnMenuChatManager(WPARAM wParam);
	int FindChatRoomIndex(int nRoomNo);
	void OnBnClickedTabFavorite();
	void OnBnClickedTabChatList();
	void OnMenuFavoriteAdd(WPARAM wParam);
	void MakeFavoriteMenu(CMenu* menu, int nSub);
	void GetSelectedUserIDList(CStringList &selectedIdList);
	BOOL IsAllIdsInBuddyGroup(CStringList& selectedIdList, int nGroupID);
	CString MakeHanatourLoginData(CString strLegacySystemName);
	CString StringToHex(char* pData);
	void MoveLegacyButton(CInfoItemWnd &infoItem, BOOL bEnable, LONG &nSX, LONG nSY, int &nLegacyBtnBgWidth);
	void MoveLegacyButtonReverse(CInfoItemWnd &infoItem, BOOL bEnable, LONG &nSX, LONG nSY, int &nLegacyBtnBgWidth);
	bool IsRemainRightLegacyItem();
	bool IsRemainLeftLegacyItem();
};
